package com.sos.JSHelper.Options;

import java.util.regex.Pattern;

import com.sos.JSHelper.Exceptions.JobSchedulerException;

/**
* \class SOSOptionJdbcUrl 
* 
* \brief SOSOptionJdbcUrl - 
* 
* \details
*
* \section SOSOptionJdbcUrl.java_intro_sec Introduction
*
* \section SOSOptionJdbcUrl.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author oh
* @version $Id$
* \see reference
*
* Created on 28.02.2012 00:58:20
 */
/**
 * @author oh
 *
 */
public class SOSOptionJdbcUrl extends SOSOptionString {
	/**
	 * 
	 */
	private static final long	serialVersionUID	= 299275037361239344L;
	private final String		conClassName	= "SOSOptionJdbcUrl";
	
	/**
	 * \brief SOSOptionJdbcUrl
	 *
	 * \details
	 *
	 * @param pPobjParent
	 * @param pPstrKey
	 * @param pPstrDescription
	 * @param pPstrValue
	 * @param pPstrDefaultValue
	 * @param pPflgIsMandatory
	 */
	public SOSOptionJdbcUrl(JSOptionsClass pPobjParent, String pPstrKey, String pPstrDescription, String pPstrValue, String pPstrDefaultValue,
		boolean pPflgIsMandatory) {
		super(pPobjParent, pPstrKey, pPstrDescription, pPstrValue, pPstrDefaultValue, pPflgIsMandatory);
	}
	
	@Override
	public void Value(final String pstrValue) {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::Value";
		String patternString 	= "jdbc:(mysql|postgresql|oracle:[^:]+|sqlserver|jtds:sqlserver|jtds:sybase|sybase:Tds|firebirdsql|db2):(@|@?//|)?[^:]+(:[0-9]{1,5})?((:|/)[^:;\\?]+)?((\\?|:|;)[^=]+=[^&;]+)?(?:(&|;)[^=]+=[^&;]+)*";
		Pattern pattern 		= Pattern.compile(patternString);
		super.Value(pstrValue);
		if(this.isNotEmpty(this.strValue) && !pattern.matcher(this.strValue).matches()) {
			throw new JobSchedulerException(String.format("invalid syntax in JDBC URL (\"%1$s\").", this.strValue));
        }
	} // private void Value
}
