package com.sos.VirtualFileSystem.Interfaces;

import java.io.IOException;
import java.util.Vector;

import com.sos.VirtualFileSystem.DataElements.SOSFileList;
import com.sos.VirtualFileSystem.DataElements.SOSFolderName;

/**
* \class ISOSVirtualFolder 
* 
* \brief ISOSVirtualFolder - 
* 
* \details
*
* \section ISOSVirtualFolder.java_intro_sec Introduction
*
* \section ISOSVirtualFolder.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author KB
* @version $Id$21.05.2010
* \see reference
*
* Created on 21.05.2010 11:02:14
 */

/**
 * @author KB
 *
 */
public interface ISOSVirtualFolder {

	/**
	 * return a listing of the files in a directory in long format on
	 * the remote machine
	 * @param pathname on remote machine
	 * @return a listing of the contents of a directory on the remote machine
	 * @exception Exception
	 * @see #nList()
	 * @see #nList( String )
	 * @see #dir()
	 */
	public SOSFileList dir( final SOSFolderName pobjFolderName );
	public SOSFileList dir(String pathname, int flag) ;
	public SOSFileList dir();

	/**
	 * 
	 * \brief mkdir - create a directory
	 * 
	 * \details
	 * Creates a (sub)directory on the FTP server in the current directory .
	 * 
	 * \return ISOSVirtualFolder
	 *
	 * @param pobjFolderName
	 * @throws IOException
	 */
	
	public ISOSVirtualFolder mkdir (final SOSFolderName pobjFolderName) throws IOException;
	
	/**
	 * 
	 * \brief rmdir - remove directory
	 * 
	 * \details
	 * Removes a directory on the FTP server (if empty).
	 * 
	 * \return boolean
	 *
	 * @param pobjFolderName
	 * @throws IOException
	 */
	
	public boolean rmdir(final SOSFolderName pobjFolderName) throws IOException;
	

}
