package com.sos.scheduler.model.objects;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import org.apache.log4j.Logger;
import org.joda.time.Interval;

import com.sos.scheduler.model.ISOSJsObjStartTimes;
import com.sos.scheduler.model.SchedulerObjectFactory;
import com.sos.scheduler.model.tools.RunTimeElements;

/**
* \class JSObjWeekdays 
* 
* \brief JSObjWeekdays - 
* 
* \details
*
* \section JSObjWeekdays.java_intro_sec Introduction
*
* \section JSObjWeekdays.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author oh
* @version $Id$
* \see reference
*
* Created on 09.02.2011 15:24:39
 */

/**
 * @author oh
 *
 */
public class JSObjWeekdays extends Weekdays implements ISOSJsObjStartTimes {

	@SuppressWarnings("unused")
	private final String		conClassName	= "JSObjWeekdays";
	@SuppressWarnings("unused")
	private static final Logger	logger			= Logger.getLogger(JSObjWeekdays.class);

	public JSObjWeekdays (SchedulerObjectFactory schedulerObjectFactory) {
		super();
		objFactory = schedulerObjectFactory;
	}

	@Override
	public RunTimeElements getRunTimeElements(Interval timeRange) {
		RunTimeElements result = new RunTimeElements(timeRange);
		Iterator<Day> it = getDay().iterator();
		while(it.hasNext()) {
			Day d = it.next();
			JSObjWeekdaysDay day = new JSObjWeekdaysDay(objFactory);
			day.setObjectFieldsFrom(d);
			result.putAll(day.getRunTimeElements(timeRange));
		}
//		Collections.sort(result, DateTimeComparator.getInstance());
		return result;
	}
	
	public List<JSObjWeekdaysDay> getJsObjDay() {
		List<JSObjWeekdaysDay> result = new ArrayList<JSObjWeekdaysDay>();
		Iterator<Day> it = getDay().iterator();
		while(it.hasNext()) {
			Day d = it.next();
			JSObjWeekdaysDay day = new JSObjWeekdaysDay(objFactory);
			day.setObjectFieldsFrom(d);
			day.setHotFolderSrc(getHotFolderSrc());
			result.add(day);
		}
		return result;
	}

}
